#ifndef _GanttCtrl_Test_GanttCtrl_h_
#define _GanttCtrl_Test_GanttCtrl_h_

namespace Upp {
namespace GraphDraw_ns {

#include "GanttGridAxisDraw.h"


struct GanttCtrlDefaultTypes {
		typedef GanttCtrlDefaultTypes                                                      Types;
		typedef GraphDraw_ns::GenericCoordinateConverter                                   X_TypeCoordConverter;
		typedef GraphDraw_ns::GenericCoordinateConverter                                   X2_TypeCoordConverter;
		typedef GraphDraw_ns::GenericCoordinateConverter                                   Y_TypeCoordConverter;
		typedef GraphDraw_ns::GenericCoordinateConverter                                   Y2_TypeCoordConverter;
		typedef GraphDraw_ns::StdGridAxisECtrl<Types, GraphDraw_ns::GanttGridAxisDraw >    X_TypeGridAxisDraw;
		typedef GraphDraw_ns::StdGridAxisECtrl<Types, GraphDraw_ns::GridAxisDraw >         X2_TypeGridAxisDraw;
		typedef GraphDraw_ns::StdGridAxisECtrl<Types, GraphDraw_ns::GridAxisDraw >         Y_TypeGridAxisDraw;
		typedef GraphDraw_ns::StdGridAxisECtrl<Types, GraphDraw_ns::GridAxisDraw >         Y2_TypeGridAxisDraw;
		typedef GraphDraw_ns::StdLabelECtrl<Types,GraphDraw_ns::LabelElement>              TypeLabelElement;
		typedef GraphDraw_ns::StdLegendECtrl<Types, GraphDraw_ns::LegendElement >          TypeLegendElement;
		typedef GraphDraw_ns::StdBlankAreaECtrl<Types, GraphDraw_ns::BlankAreaElement >    TypeBlankElement;
		typedef GraphDraw_ns::DynamicMarkerECtrl< Types >                                  TypeMarkerElement;
};


class GanttCtrl : public GraphDraw_ns::GD_XYLTMM_GraphCtrl< GanttCtrlDefaultTypes, GanttCtrl > {
	public:
		typedef GanttCtrl  CLASSNAME;
		typedef GraphDraw_ns::GD_XYLTMM_GraphCtrl< GanttCtrlDefaultTypes, CLASSNAME > _B;
		
		GanttCtrl() {
			_B::SetStyle( StyleDefault() );
			GetX1GridAxisDraw().SetGanttGridSteps();
			GetX1GridAxisDraw().SetElementPos(TOP_OF_GRAPH);
		}
		virtual ~GanttCtrl() {}
		
		static const Style& StyleDefault();


		
};

} // namespace GraphDraw_ns
} // namespace Upp

#endif
